/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT MODIFY */

/*
 * schema-defined QMP->QAPI command dispatch
 *
 * Copyright IBM, Corp. 2011
 *
 * Authors:
 *  Anthony Liguori   <aliguori@us.ibm.com>
 *
 * This work is licensed under the terms of the GNU LGPL, version 2.1 or later.
 * See the COPYING.LIB file in the top-level directory.
 *
 */

#include "qemu-objects.h"
#include "qapi/qmp-core.h"
#include "qapi/qapi-visit-core.h"
#include "qapi/qmp-output-visitor.h"
#include "qapi/qmp-input-visitor.h"
#include "qapi/qapi-dealloc-visitor.h"
#include "rhev-qapi-types.h"
#include "rhev-qapi-visit.h"

#include "rhev-qmp-commands.h"

int qmp_marshal_input___com_redhat_block_commit(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    char * device = NULL;
    bool has_base = false;
    char * base = NULL;
    char * top = NULL;
    bool has_speed = false;
    int64_t speed;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_str(v, &device, "device", errp);
    visit_start_optional(v, &has_base, "base", errp);
    if (has_base) {
        visit_type_str(v, &base, "base", errp);
    }
    visit_end_optional(v, errp);
    visit_type_str(v, &top, "top", errp);
    visit_start_optional(v, &has_speed, "speed", errp);
    if (has_speed) {
        visit_type_int(v, &speed, "speed", errp);
    }
    visit_end_optional(v, errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp___com_redhat_block_commit(device, has_base, base, top, has_speed, speed, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_str(v, &device, "device", errp);
    visit_start_optional(v, &has_base, "base", errp);
    if (has_base) {
        visit_type_str(v, &base, "base", errp);
    }
    visit_end_optional(v, errp);
    visit_type_str(v, &top, "top", errp);
    visit_start_optional(v, &has_speed, "speed", errp);
    if (has_speed) {
        visit_type_int(v, &speed, "speed", errp);
    }
    visit_end_optional(v, errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

int qmp_marshal_input_transaction(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    BlockdevActionList * actions = NULL;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_BlockdevActionList(v, &actions, "actions", errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp_transaction(actions, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_BlockdevActionList(v, &actions, "actions", errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

int qmp_marshal_input_blockdev_snapshot_sync(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    char * device = NULL;
    char * snapshot_file = NULL;
    bool has_format = false;
    char * format = NULL;
    bool has_mode = false;
    NewImageMode mode;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &snapshot_file, "snapshot-file", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_mode, "mode", errp);
    if (has_mode) {
        visit_type_NewImageMode(v, &mode, "mode", errp);
    }
    visit_end_optional(v, errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp_blockdev_snapshot_sync(device, snapshot_file, has_format, format, has_mode, mode, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &snapshot_file, "snapshot-file", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_mode, "mode", errp);
    if (has_mode) {
        visit_type_NewImageMode(v, &mode, "mode", errp);
    }
    visit_end_optional(v, errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

int qmp_marshal_input___com_redhat_drive_reopen(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    char * device = NULL;
    char * new_image_file = NULL;
    bool has_format = false;
    char * format = NULL;
    bool has_witness = false;
    char * witness = NULL;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &new_image_file, "new-image-file", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_witness, "witness", errp);
    if (has_witness) {
        visit_type_str(v, &witness, "witness", errp);
    }
    visit_end_optional(v, errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp___com_redhat_drive_reopen(device, new_image_file, has_format, format, has_witness, witness, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &new_image_file, "new-image-file", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_witness, "witness", errp);
    if (has_witness) {
        visit_type_str(v, &witness, "witness", errp);
    }
    visit_end_optional(v, errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

int qmp_marshal_input___com_redhat_drive_mirror(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    char * device = NULL;
    char * target = NULL;
    bool has_format = false;
    char * format = NULL;
    bool has_speed = false;
    int64_t speed;
    bool has_full = false;
    bool full;
    bool has_mode = false;
    NewImageMode mode;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &target, "target", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_speed, "speed", errp);
    if (has_speed) {
        visit_type_int(v, &speed, "speed", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_full, "full", errp);
    if (has_full) {
        visit_type_bool(v, &full, "full", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_mode, "mode", errp);
    if (has_mode) {
        visit_type_NewImageMode(v, &mode, "mode", errp);
    }
    visit_end_optional(v, errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp___com_redhat_drive_mirror(device, target, has_format, format, has_speed, speed, has_full, full, has_mode, mode, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_str(v, &device, "device", errp);
    visit_type_str(v, &target, "target", errp);
    visit_start_optional(v, &has_format, "format", errp);
    if (has_format) {
        visit_type_str(v, &format, "format", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_speed, "speed", errp);
    if (has_speed) {
        visit_type_int(v, &speed, "speed", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_full, "full", errp);
    if (has_full) {
        visit_type_bool(v, &full, "full", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_mode, "mode", errp);
    if (has_mode) {
        visit_type_NewImageMode(v, &mode, "mode", errp);
    }
    visit_end_optional(v, errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

static void qmp_marshal_output_query_events(EventInfoList * ret_in, QObject **ret_out, Error **errp)
{
    QapiDeallocVisitor *md = qapi_dealloc_visitor_new();
    QmpOutputVisitor *mo = qmp_output_visitor_new();
    Visitor *v;

    v = qmp_output_get_visitor(mo);
    visit_type_EventInfoList(v, &ret_in, "unused", errp);
    if (!error_is_set(errp)) {
        *ret_out = qmp_output_get_qobject(mo);
    }
    qmp_output_visitor_cleanup(mo);
    v = qapi_dealloc_get_visitor(md);
    visit_type_EventInfoList(v, &ret_in, "unused", errp);
    qapi_dealloc_visitor_cleanup(md);
}

int qmp_marshal_input_query_events(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    EventInfoList * retval = NULL;
    (void)args;
    if (error_is_set(errp)) {
        goto out;
    }
    retval = qmp_query_events(errp);
    if (!error_is_set(errp)) {
        qmp_marshal_output_query_events(retval, ret, errp);
    }

out:


    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

int qmp_marshal_input_dump_guest_memory(Monitor *mon, const QDict *qdict, QObject **ret)
{
    Error *local_err = NULL;
    Error **errp = &local_err;
    QDict *args = (QDict *)qdict;
    QmpInputVisitor *mi;
    QapiDeallocVisitor *md;
    Visitor *v;
    bool paging;
    char * protocol = NULL;
    bool has_begin = false;
    int64_t begin;
    bool has_length = false;
    int64_t length;

    mi = qmp_input_visitor_new(QOBJECT(args));
    v = qmp_input_get_visitor(mi);
    visit_type_bool(v, &paging, "paging", errp);
    visit_type_str(v, &protocol, "protocol", errp);
    visit_start_optional(v, &has_begin, "begin", errp);
    if (has_begin) {
        visit_type_int(v, &begin, "begin", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_length, "length", errp);
    if (has_length) {
        visit_type_int(v, &length, "length", errp);
    }
    visit_end_optional(v, errp);
    qmp_input_visitor_cleanup(mi);

    if (error_is_set(errp)) {
        goto out;
    }
    qmp_dump_guest_memory(paging, protocol, has_begin, begin, has_length, length, errp);

out:
    md = qapi_dealloc_visitor_new();
    v = qapi_dealloc_get_visitor(md);
    visit_type_bool(v, &paging, "paging", errp);
    visit_type_str(v, &protocol, "protocol", errp);
    visit_start_optional(v, &has_begin, "begin", errp);
    if (has_begin) {
        visit_type_int(v, &begin, "begin", errp);
    }
    visit_end_optional(v, errp);
    visit_start_optional(v, &has_length, "length", errp);
    if (has_length) {
        visit_type_int(v, &length, "length", errp);
    }
    visit_end_optional(v, errp);
    qapi_dealloc_visitor_cleanup(md);

    if (local_err) {
        qerror_report_err(local_err);
        error_free(local_err);
        return -1;
    }
    return 0;
}

